/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/**
    @file AsteroidsStone.h
    @brief Declaration of the AsteroidsStone class.
*/

#ifndef _AsteroidsStone_H__
#define _AsteroidsStone_H__

#include "asteroids/AsteroidsPrereqs.h"

#include "worldentities/Pawn.h"
#include "core/object/Context.h"

namespace orxonox
{
    class _AsteroidsExport AsteroidsStone : public Pawn
    {
        public:
            AsteroidsStone(Context* context);
            virtual void tick(float dt) override;

            //Es gibt 3 Groessen von Meteroiden gross, mittel, klein, gross ->2 mittleren, mittel -> 2 kleinen, kleine-> verschwinden
            int size;

            virtual void setAsteroidsPlayer(AsteroidsShip* player){this->player = player;}
            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;



        protected:

            Asteroids* getGame();
            WeakPtr<Asteroids> game;

            virtual void death() override;


            //herausfinden->ueber Kamera Einstellung wie bei Pong?
            float fieldWidth_;
            float fieldHeight_;
            Vector2 velocity;
            float maxspeed;
            float direction;

    };
}

#endif /* _AsteroidsStone_H__ */
